﻿using System;
using System.IO;
using System.Windows.Forms;

namespace Archives_Center
{
    public partial class CreateLog : Form
    {
        public CreateLog()
        {
            InitializeComponent();
            textBox2.Text = Properties.Settings.Default.current_user;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            DateTime selectedDateTime = dateTimePicker1.Value;
            int year = selectedDateTime.Year;
            int month = selectedDateTime.Month;
            int day = selectedDateTime.Day;
            string yearString = year.ToString();
            string monthString = month.ToString();
            string dayString = day.ToString();
            listBox1.Items.Clear();
            string folderPath = Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + dateTimePicker1.Text;
            if (tabControl1.Enabled == true)
            {
                string[] jpgFiles = Directory.GetFiles(folderPath, "*.jpg");
                foreach (string filePath in jpgFiles)
                {
                    string fileName = Path.GetFileName(filePath);
                    listBox1.Items.Add(fileName);
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            DateTime selectedDateTime = dateTimePicker1.Value;
            int year = selectedDateTime.Year;
            int month = selectedDateTime.Month;
            int day = selectedDateTime.Day;
            string yearString = year.ToString();
            string monthString = month.ToString();
            string dayString = day.ToString();
            if(!Directory.Exists(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + dateTimePicker1.Text))
                Directory.CreateDirectory(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + dateTimePicker1.Text);
            using (StreamWriter writer = new StreamWriter(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + dateTimePicker1.Text + @"\" + "text.txt"))
            {
                writer.WriteLine(textBox1.Text);
                writer.WriteLine(dateTimePicker1.Value.ToString());
                writer.WriteLine(textBox2.Text);
                writer.WriteLine(richTextBox1.Text);
            }
            this.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Title = "选择导入的图片";
            openFileDialog.Filter = "JPEG图片文件 (*.jpg)|*.jpg|所有文件 (*.*)|*.*";
            openFileDialog.Multiselect = true;
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                string[] selectedFiles = openFileDialog.FileNames;
                DateTime selectedDateTime = dateTimePicker1.Value;
                int year = selectedDateTime.Year;
                int month = selectedDateTime.Month;
                int day = selectedDateTime.Day;
                string yearString = year.ToString();
                string monthString = month.ToString();
                string dayString = day.ToString();
                string destinationDirectory = Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + dateTimePicker1.Text;
                foreach (string selectedFile in selectedFiles)
                {
                    string fileName = Path.GetFileName(selectedFile);
                    string destinationPath = Path.Combine(destinationDirectory, fileName);
                    File.Copy(selectedFile, destinationPath);
                }
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //DateTime selectedDateTime = dateTimePicker1.Value;
            //int year = selectedDateTime.Year;
            //int month = selectedDateTime.Month;
            //int day = selectedDateTime.Day;
            //string yearString = year.ToString();
            //string monthString = month.ToString();
            //string dayString = day.ToString();
            //string folderPath = Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + dateTimePicker1.Text;
            //if (Directory.Exists(folderPath))
            //{
            //    Directory.Delete(folderPath, true);
            //}
            //this.Close();
        }

        private void listBox1_Click(object sender, EventArgs e)
        {
            if (listBox1.SelectedItem != null)
            {
                string selectedFileName = listBox1.SelectedItem.ToString();
                DateTime selectedDateTime = dateTimePicker1.Value;
                int year = selectedDateTime.Year;
                int month = selectedDateTime.Month;
                int day = selectedDateTime.Day;
                string yearString = year.ToString();
                string monthString = month.ToString();
                string dayString = day.ToString();
                string folderPath = Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + dateTimePicker1.Text;
                string filePath = Path.Combine(folderPath, selectedFileName);
                File.Delete(filePath);
                listBox1.Items.Remove(selectedFileName);
            }
        }

        private void dateTimePicker1_ValueChanged(object sender, EventArgs e)
        {
            DateTime selectedDateTime = dateTimePicker1.Value;
            int year = selectedDateTime.Year;
            int month = selectedDateTime.Month;
            int day = selectedDateTime.Day;
            string yearString = year.ToString();
            string monthString = month.ToString();
            string dayString = day.ToString();
            if(Directory.Exists(Path.GetTempPath() + @"ArchivesCenter\Data\" + Properties.Settings.Default.current_user + @"\" + yearString + @"\" + monthString + @"\" + dateTimePicker1.Text))
            {
                DialogResult Ans = MessageBox.Show("检测到当前日期已存在日志，是否修改？", "Archives Center检测到错误", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);
                if (Ans == DialogResult.Yes)
                {

                }
                else if (Ans == DialogResult.No)
                    button1.Text = "覆盖";
            }
        }
    }
}